crm.ProjetWeb/Controllers/PromotionController.cs
using crm.Data.infrastructure;
using crm.Domain.Entity;
using crm.ProjetWeb.Models;
using crm.Services;
using crm.ServicesPattern;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace crm.ProjetWeb.Controllers
{
    public class PromotionController : Controller
    {


        IPromotionService Service = new PromotionService();

        // GET: Promotion
        public ActionResult Index()
        {
            IDataBaseFactory Factory = new DataBaseFactory();
            IUnitOfWork Uok = new UnitOfWork(Factory);
            IService<Promotion> ProService = new Service<Promotion>(Uok);

            return View(ProService.GetAll().ToList());
        }

        // GET: Promotions/Details/5
        public ActionResult Details(int id)
        {
            Promotion cm = new Promotion();
            cm = Service.GetById(id);
            Promotion c = new Promotion();


            c.ProduitId = cm.ProduitId;
            c.NomPromo = cm.NomPromo;
            c.PrDateDebut = cm.PrDateDebut;
            c.PrDateFin = cm.PrDateFin;
            c.PromoId = cm.PromoId;
            c.PromoPrix = cm.PromoPrix;
            c.PromoImage = cm.PromoImage;


            return View(c);
        }

        // GET: Promotion/Create
        public ActionResult Create()
        {
            
            IProduitService m = new ProduitService();
            
           
            var listDesProduits = m.GetAll();

            
            ViewBag.listDesProduits = new SelectList(listDesProduits, "ProduitId", "nomProd");




            return View();
        }


       

        // POST: Promotion/Create
        [HttpPost]
        public ActionResult Create(Promotion pr, HttpPostedFileBase Image)
        {



            pr.PromoImage = Image.FileName;
            var path = Path.Combine(Server.MapPath("~/Content/Upload/"), Image.FileName);
            Image.SaveAs(path);


            //if (!ModelState.IsValid || Image == null || Image.ContentLength == 0)
            //{
            //    RedirectToAction("Create");
            //}

            //Service.Add(new Promotion()
            //{
            //    PrDateDebut = pr.PrDateDebut.T,
            //    location = e.location


            //});
            //es.Commit();

           





            Service.Add(pr);
            Service.Commit();





            return RedirectToAction("Index");
        }





        // GET: Promotion/Edit/5
        public ActionResult Edit(int id)
        {

            IProduitService m = new ProduitService();
            
           
            var listDesProduits = m.GetAll();

            
            ViewBag.listDesProduits = new SelectList(listDesProduits, "ProduitId", "nomProd");


            
            if (id == null)

                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            Promotion p = Service.GetById(id);
            Promotion p1 = new Promotion();
            {

                p1.PromoId = p.PromoId;
                p1.NomPromo = p.NomPromo;
                p1.PrDateDebut = p.PrDateDebut;
                p1.PrDateFin = p.PrDateFin;
                p1.Description = p.Description;
                p1.PromoImage = p.PromoImage;
                p1.PromoPrix = p.PromoPrix;
                p1.ProduitId = p.ProduitId;

            };
            if (p == null)
                return HttpNotFound();
            return View(p1);

            return RedirectToAction("Index");

        }

        // POST: Promotion/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, Promotion pr)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    if (id == null)
                        return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
                    Promotion p = Service.GetById(id);


                    p.PromoId = pr.PromoId;
                    p.NomPromo = pr.NomPromo;
                    p.PrDateDebut = pr.PrDateDebut;
                    p.PrDateFin = pr.PrDateFin;
                    p.Description = pr.Description;
                    p.PromoImage = pr.PromoImage;
                    p.PromoPrix = pr.PromoPrix;



                    if (p == null)
                        return HttpNotFound();

                    Service.Update(p);
                    Service.Commit();
                    // Service.Dispose();

                    return RedirectToAction("Index");
                }
                // TODO: Add delete logic here
                //  return View(ovm);

            }
            catch
            {
                return View("Index");
            }
            return null;

        }
            public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Promotion/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            Promotion e;
            e = Service.GetById(id);

            Service.Delete(e);
            Service.Commit();
            //Service.dispose();

            return RedirectToAction("Index");
        }
    }
}

crm.ProjetWeb/Views/Promotion/Create.cshtml
@model crm.Domain.Entity.Promotion

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Create</h2>


@using (Html.BeginForm("Create", "Promotion", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
<div class="form-horizontal">
    <h4>Promotion</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
   
    <div class="form-group">
        @Html.LabelFor(model => model.NomPromo, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.NomPromo, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.NomPromo, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="form-group">
        @Html.LabelFor(model => model.PromoImage, htmlAttributes: new { @class = "control-label col-md-2" })

        <div class="col-md-10">
            @Html.TextBox("Image", null, new { type = "file" })
            @Html.ValidationMessageFor(model => model.PromoImage)
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PrDateDebut, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.PrDateDebut, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.PrDateDebut, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PrDateFin, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.PrDateFin, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.PrDateFin, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PromoPrix, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.PromoPrix, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.PromoPrix, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.ProduitId, "ProduiId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("ProduitId", (SelectList)ViewData["listDesProduits"], htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.ProduitId)
        </div>
    </div>

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Create" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

crm.ProjetWeb/Views/Promotion/Delete.cshtml
@model crm.Domain.Entity.Promotion

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Promotion</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.produit.nomProd)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.produit.nomProd)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NomPromo)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NomPromo)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PromoImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PromoImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PrDateDebut)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PrDateDebut)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PrDateFin)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PrDateFin)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PromoPrix)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PromoPrix)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

crm.ProjetWeb/Views/Promotion/Details.cshtml
@model crm.Domain.Entity.Promotion

@{
    ViewBag.Title = "Details";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Details</h2>

<div>
    <h4>Promotion</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.produit.nomProd)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.produit.nomProd)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NomPromo)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NomPromo)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PromoImage)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PromoImage)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PrDateDebut)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PrDateDebut)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PrDateFin)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PrDateFin)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PromoPrix)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PromoPrix)
        </dd>

    </dl>
</div>
<p>
    @*@Html.ActionLink("Edit", "Edit", new { id = Model.PromoId }) |*@
    @Html.ActionLink("Back to List", "Index")
</p>

crm.ProjetWeb/Views/Promotion/Edit.cshtml
@model crm.Domain.Entity.Promotion

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Edit</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Promotion</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.PromoId)

        <div class="form-group">
            @Html.LabelFor(model => model.NomPromo, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NomPromo, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.NomPromo, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PromoImage, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PromoImage, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PromoImage, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PrDateDebut, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PrDateDebut, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PrDateDebut, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PrDateFin, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PrDateFin, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PrDateFin, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PromoPrix, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PromoPrix, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PromoPrix, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProduitId, "ProduiId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("ProduitId", (SelectList)ViewData["listDesProduits"], htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.ProduitId)
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

crm.ProjetWeb/Views/Promotion/Index.cshtml
@model IEnumerable<crm.Domain.Entity.Promotion>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_AdminLayout.cshtml";
}

<h2>Liste Des Promotions</h2>

<p>
    @Html.ActionLink("Ajouter Une Promotion", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.produit.nomProd)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.NomPromo)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Description)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.PromoImage)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.PrDateDebut)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.PrDateFin)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.PromoPrix)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.produit.nomProd)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.NomPromo)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Description)
        </td>
        <td>
            @{string path = "~/Content/Upload/" + @item.PromoImage;}
            
            <img src="@Url.Content(path)" width="160" height="135" />
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.PrDateDebut)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.PrDateFin)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.PromoPrix)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.PromoId }) |
            @Html.ActionLink("Details", "Details", new { id=item.PromoId }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.PromoId })
        </td>
    </tr>
}

</table>